#!/bin/bash

lockedUserListFile="/var/log/msd-locked-user-list"
lockedFialedUserListFile="/var/log/msd-lock-fialed-user-list"
unlockedFialedUserListFile="/var/log/msd-unlock-fialed-user-list"

if [ "$1" = "true" ]; then
    #user_can_be_locked=`cat /etc/passwd|grep /bin/bash |awk -F ":"  '{print $1}' |grep -v root |grep -v secadm`
    user_can_be_locked=`cat /etc/passwd|grep /bin/bash |awk -F ":"  '{print $1}' |grep -v secadm`
    #    echo $user_can_be_locked

    if [ ! -f "$lockedUserListFile" ];then
        touch $lockedUserListFile
    fi

    for user in $user_can_be_locked
        do
            user_passwd=`sed -n "/$user/p" /etc/shadow |awk -F ":" '{print $2}'`
            passwd_first_char=${user_passwd:0:1} #if not use bash, there will be syntax error  
#            echo $passwd_first_char
            if [ "$passwd_first_char" != "!" ];then
                usermod -L $user
                if [ $? -eq 0 ];then
                    echo "成功锁定用户："$user
                    echo $user >> $lockedUserListFile
                else
                    echo "锁定用户失败："$user >> $lockedFialedUserListFile
                    date >> $lockedFialedUserListFile
                fi
            fi
        done
    #sed -i 's/^autologin-user =.*$/autologin-user =/g' /usr/share/lightdm/lightdm.conf.d/96-kylin-setting.conf
    #systemctl restart lightdm

elif [ "$1" = "logout" ]; then
    sed -i 's/^autologin-user=.*$/autologin-user=/g' /usr/share/lightdm/lightdm.conf.d/96-kylin-setting.conf
    systemctl restart lightdm

elif [ "$1" = "false" ];then
    if [ -f $lockedUserListFile ];then
        #user_locked_list=`cat $lockedUserListFile`
        rm $lockedUserListFile
    fi
    user_locked_list=`cat /etc/passwd|grep /bin/bash |awk -F ":"  '{print $1}' |grep -v secadm`
#    echo $user_locked_list
    for user in $user_locked_list
        do
            echo $user
            usermod -U $user
            if [ $? -eq 0 ];then
                echo "解锁用户成功："$user
            else
                echo "解锁用户失败："$user >> $unlockedFialedUserListFile
                date >> $unlockedFialedUserListFile
            fi
        done

else
    echo "参数错误"
fi
